<template>
    <div class="v-input">
        <p
            class="v-input__hint"
            :class="{'v-input__hint_error': isError}"
            v-if="hint"
        >
            {{ hint }}
            <span v-if="isError">*</span>
        </p>
        <div
            class="v-input__wrapper"
            :class="{
                'v-input__wrapper_error': isError,
                'v-input__wrapper_focused': isFocusedInput,
                'v-input__wrapper_disabled': isDisabled,
            }"
            @click="clickInput"
        >
            <textarea
                v-if="textarea"
                :value="modelValue"
                :disabled="isDisabled"
                :placeholder="isFocusedInput ? '' : placeholder"
                class="v-input__textarea"
                @focus="focus"
                @blur="blur"
                @input="input"
            ></textarea>
            <input
                v-else
                v-imask="mask"
                :value="modelValue"
                :disabled="isDisabled"
                :placeholder="isFocusedInput ? '' : placeholder"
                :maxlength="maxLength"
                class="v-input__input"
                :type="inputType"
                @focus="focus"
                @blur="blur"
                @input="input"
                @keyup.enter="onEnter"
            />
        </div>
        <!-- <div v-if="isError" class="input-error">Обязательное поле не заполнено</div> -->
    </div>
</template>

<script>
import {IMaskDirective} from 'vue-imask';

export default {
    name: 'v-input',

    directives: {
        imask: IMaskDirective
    },

    props: {
        modelValue: {
            type   : String,
            default: ''
        },

        placeholder: {
            type   : String,
            default: ''
        },

        isError: {
            type   : Boolean,
            default: false
        },

        hint: {
            type   : String,
            default: ''
        },

        isDisabled: {
            type   : Boolean,
            default: false
        },

        inputType: {
            type   : String,
            default: 'text',
            validate(value) {
                return ['text', 'phone', 'name', 'email'].includes(value);
            }
        },

        textarea: {
            type   : Boolean,
            default: false
        }
    },

    data() {
        return {
            isFocusedInput: false,
            
        };
    },

    computed: {
        mask() {
            if (!this.isFocusedInput) {
                return '';
            }

            if (this.inputType === 'phone') {
                return {mask: '{+7} (000) 000-00-00'};
            }

            if (this.inputType === 'name') {
                return {mask: new RegExp(/^[а-яА-ЯёЁa-zA-Z\s]*$/)};
            }

            return '';
        },

        maxLength() {
            return this.inputType === 'phone' ? 18 : null;
        }
    },

    methods: {
        clickInput() {
            if (this.isDisabled) {
                return;
            }
            this.$emit('click');
        },
        onEnter() {
            if (this.isDisabled) {
                return;
            }
            this.$emit('enter');
        },

        input(event) {
            const value = event.target.value.trim();
            this.$emit('update:modelValue', value);
        },

        focus() {
            this.isFocusedInput = true;
        },

        blur() {
            this.$emit('blur');
            this.isFocusedInput = false;
        }
    }
};
</script>